#ObserverSwarm.py
from ModelSwarm import *
from Tools import *
from Agent import *
from ActionGroup import *
from oActions import *
from turtle import *
from Pen import *

cycle=1

class ObserverSwarm:

    # creation step
    def __init__(self, project0):
        global project
        project=project0
        self.v=[]
        if project=='school':
            self.p=Pen(0,0)
            self.p.white(-200,150)
        else: self.p=0

    # create objects
    def buildObjects(self):
        global cycle
        cycle=1
        mySeed = input("random number seed (1 to get it from the clock) ")
        if mySeed == 1:
           random.seed()
        else:
           random.seed(mySeed)
        self.nAgents = input("How many 'bland' agents? ")
        self.worldXSize= input("X Size of the world? ")
        self.worldYSize= input("Y Size of the world? ")
        self.nCycles = input("How many cycles? (0 = exit) ")
        self.conclude=False

        self.modelSwarm = ModelSwarm(self.nAgents,
                           self.worldXSize, self.worldYSize, project)
        self.modelSwarm.buildObjects()


    # actions
    def buildActions(self):

        global project
        print "#### Project", project,"starting."     
        print

        observerActions=open("./"+project+"/observerActions.txt")
        self.actionList=observerActions.read().split()
        observerActions.close()

        self.modelSwarm.buildActions()

        # clock, do not remove or move from here; the position in
        # list can be also different
        self.actionGroup1 = ActionGroup (self.actionList[2])
        def do1(address, nCycles, actionList):
            global cycle
            cycle+=1 #the clock running
            print "Time =%2d" % cycle
            if cycle>nCycles:
                 insertElementNextPosition(actionList,"end")
        self.actionGroup1.do = do1 # do is a variable linking a method
    
        self.actionGroup2a = ActionGroup (self.actionList[1])
        self.actionGroup2a.do = do2a # do is a variable linking a method
    
        self.actionGroup2b = ActionGroup (self.actionList[4])
        self.actionGroup2b.do = do2b # do is a variable linking a method

        # previous steps, if empty, are defined in the specific
        # oAction.py file
        # repeat for new or different steps

        # do not remove or move from here and dot not rename
        self.actionGroup3 = ActionGroup ("end")
        def do3(address):
            self.conclude=True
        self.actionGroup3.do = do3 # do is a variable linking a method

        

    # run
    def run(self):
        global cycle
        print "Time =%2d" % cycle

        if self.nCycles==0: print "The # of required cycles is 0. "
        while not self.conclude and self.nCycles>0:
            
            localEventList=self.actionList[:]   

            while len(localEventList)>0 and not self.conclude:
                subStep=extractASubStep(localEventList)

                if subStep == "modelStep":
                    self.modelSwarm.step(cycle)
                    # in a reasonable way, the model makes a step before
                    # that the observer looks at the effects of model actions
 
                if subStep == "clock":
                    self.actionGroup1.do(self, self.nCycles, localEventList)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable
 
                if subStep == self.actionList[1]:
                    self.actionGroup2a.do(self, cycle)

                if subStep == self.actionList[4]:
                    self.actionGroup2b.do(self, cycle)

                if subStep == "end":
                    self.actionGroup3.do(self)
                    raw_input("enter to conclude")
                    bye()

        if self.modelSwarm.getFile() != "": self.modelSwarm.getFile().close()
